#include "dac.h"

/*****************************************************************************
 ** Function name:		dac_init
 **
 ** Descriptions:		Enable DAC chipselect pin
 **
 ** parameters:			None
 **
 ** Returned value:		None
 ** 
 *****************************************************************************/
void dac_init(void)
{
	/* Initialize GPIO controller */
	gpio_init(); 
	
	/*Enable DAC chipselect pin */
	gpio_enable_pin(DAC_CS);

	/*set chipselect pin as output*/
	gpio_direction_output(DAC_CS ,1);
}


/*****************************************************************************
 ** Function name:		dac_write
 **
 ** Descriptions:		Write Data to the DACR
 **
 ** parameters:			data
 **
 ** Returned value:		None
 ** 
 *****************************************************************************/

void dac_write(uint8_t dat)
{
	/* Set chip select low */
	gpio_set_pin(DAC_CS, 0);                  

	/* Send write BYTE1. */
	spi_tx_rx(0x10 | ((dat >> 4) & 0x0F));   

	 /* Send write BYTE2. */
	spi_tx_rx(0x00 | ((dat << 4) & 0xF0));  
        
        /* Set chip select high. */
	gpio_set_pin(DAC_CS, 1);                  
}


