#include "audio.h"
#include "play.h"
#include "dac.h"
#include <board.h>
#include <tempsensor.h>

/* From 1343-demo-setup.c */
extern temperature_t 	temp;
extern int8_t 		critical_temp;
extern void update_temp(void);

/*****************************************************************************
 ** Function name:		ByteRead
 **
 ** Descriptions:		Read a Byte from flash, the first
 **				parameter is the Page Address, the 2nd parameter is
 **				byte address within the page. 
 **
 ** parameters:			Page Address, byte address
 **
 ** Returned value:		byte data
 **
*****************************************************************************/ 
uint8_t ByteRead(uint32_t PageAdr, uint16_t ByteAdr) 
{
	uint8_t rdateseq[8];
	uint8_t temp;
	
	/* Send page read command, page address, byte address 
	   one by one MSB First */ 
	rdateseq[0] = DF_PAGE_READ;
	rdateseq[1] = (uint8_t)(PageAdr >> 6);
	rdateseq[2] = (uint8_t)(PageAdr << 2 | ByteAdr >> 8);
	rdateseq[3] = (uint8_t) ByteAdr;
	
	/*Four dont care bytes that follow the address bytes are needed to 
	  initialize the read operation. */ 
	rdateseq[4] = 0x00;
	rdateseq[5] = 0x00;
	rdateseq[6] = 0x00;
	rdateseq[7] = 0x00;

        /* Set chip select low */
	gpio_set_pin(FCS, 0);	

        /*write page and byte address to read a data byte */
	spi_write(rdateseq, 8);	

        /* reading data from the given address */
	temp = spi_tx_rx(0xFF);	
	
	/* Set chip select high */
	gpio_set_pin(FCS, 1);	
	return temp;
}

void play(void)
{
	srate    = 11;
	paddress = 0; 
	eadd     = 4622; 
	baddress = 0;

	while (true) {
		update_temp();
		if (temp.degree >= critical_temp) {
			break;
		}

                if ((paddress >  eadd) && (baddress == 0)) {
			paddress == 0;
			break;
                } else {
			dac_write(read_byte(paddress,baddress));
			baddress++;
			if (baddress == PGSIZE) {
				baddress = 0;
				paddress++;
			}
			microdelay(srate);
			event_poll_once();
		}
	}
}
